=begin
Copyright 2009, Chris Glasier

=end


require 'sketchup.rb'

# I like to see the menu at the top so I know where the main entry point
# for the script is. -- Jim

if (not file_loaded?("chrisglasierScenes01.rb"))
    UI.menu("Plugins").add_item("cgScenes" ){ CgScenes.start }
end



class CgScenesPagesObserver < Sketchup::PagesObserver
    def onElementAdded(pages,page)	
		CgScenes.on_element_added(pages,page)
    end
	
	def onElementRemoved(pages,page)	
		CgScenes.on_element_removed(pages,page)
    end
		
	def onContentsModified(pages)	
		CgScenes.page_contents_modified(pages)
    end
end



class CgScenesSelectionObserver < Sketchup::SelectionObserver
    # 
    attr_reader :selected
    def initialize
        @selected = nil
    end
    def onSelectionBulkChange(selection)
	    CgScenes.selection_bulk_change(selection)
    end  # def
end  # class


module CgScenes

# @mods - 0 = different scene; 1 = added by callback (no action); 2 user added/removed (stops content mod); 

	def CgScenes.on_element_added(pages,page)
	puts @mod
		if @mod != 1
			@modpage = page
			puts @modpage.name
			array =[]
			a=0
			pages.each do | page |
					if page == @modpage
						@ind = a
					end
				array.push page.name
				a += 1
			end
			array = array.join(",")
			array = [@ind,array]
			array = array.join(",")
			puts array
			@dlg.execute_script("sceneSceneAdd('#{array}');")
			@mod = 2
		end  #if
	end  #def

	def CgScenes.on_element_removed(pages,page)
		@modpage = page
		array =[]
		a=0
			pages.each do | page |
					if page == @modpage
						@ind = a
					end #if
				array.push page.name
				a += 1
			end  #do
		array =array.join(",")
		array = [@ind,array]
		array = array.join(",")
		@dlg.execute_script("sceneSceneRemove('#{array}');")
		@mod = 2
	end  #def

	
# page_contents_modified always fires so @mod is always returned to 0 whatever @mod before

	def CgScenes.page_contents_modified(pages)
			puts @mod.to_s
			if @mod == 0
			a = 0
			pages.each do | page |
				if page == pages.selected_page
					@ind = a
					puts "Modified " +@mod.to_s+" "+ pages[a].name.to_s
				end
			a = a + 1
			end
			@dlg.execute_script("sceneSceneSelect('#{@ind}');")
		end
		@mod = 0
    end

    def CgScenes.selection_bulk_change(selection)
		model = Sketchup.active_model
        entities = model.entities
		selection = model.selection 
		a = 0
		entities.each do |entity|
   			if selection[0] == entity
				@ind = a					
            end
			a += 1
			end  # loop
        puts @ind
		@dlg.execute_script("sceneComponentSelect('#{@ind}');")
    end

    def CgScenes.start
		@cgScenesPagesObserver ||= CgScenesPagesObserver.new
		@cgScenesSelectionObserver ||= CgScenesSelectionObserver.new
		
		Sketchup.active_model.pages.add_observer(@cgScenesPagesObserver)
        Sketchup.active_model.selection.add_observer(@cgScenesSelectionObserver)

        Sketchup.send_action "selectSelectionTool:"

        @dlg = UI::WebDialog.new("Scene machine", true, "Scene machine", 230, 345, 0, 0, true)
        subDir = "chrisglasierScenes/"
        fileName = "scene machine.htm"
        @dlg.set_file File.join(File.dirname(__FILE__), subDir+fileName)

        @dlg.add_action_callback("coreSet_size") {|d, p|
            a = p.split(",")
            w = Integer(a[0])
            h = Integer(a[1])
            @dlg.set_size w,h   
        }
        ########## SCENES ##########
        @dlg.add_action_callback("sceneStart") {|d, p|
            model = Sketchup.active_model
            pages = model.pages
            count = pages.count
			if count == 0
				@mod = 1		
				current = 2
				listArray = ["3D","Ortho","Trade"]
				pages.add "3D"
				pages.add "Ortho"
				pages.add "Trade"
				@mod = 0
            else
			@mod = 0
			current = 0
				listArray = []
				
				a = 0
				pages.each do | page |
				listArray.push page.name
					if page == pages.selected_page
					current = a
					end
					a = a+1
				end
			end
			listArray = listArray.join(",")
			send = [current,listArray]
			send = send.join(",")
			#puts send
			cmd = "sceneStartRun('#{send}');"
            @dlg.execute_script (cmd)     
        }
        ##### SCENE ADD
        @dlg.add_action_callback("sceneScenesAdd") {|d, p|
            model = Sketchup.active_model
            pages = model.pages
            pages.add p
            cmd = "sceneScenesAdd();"
            @dlg.execute_script (cmd)
        }
        ##### SCENE LIST
        @dlg.add_action_callback("sceneScenesList") {|d, p|
            model = Sketchup.active_model
            pages = model.pages
            array = []
            pages.each do | page |
                array[a] = []
            array[a][0] = page.name
            array[a][1] = a
            array[a] = array[a].join(",")
            a+=1
            end  #loop
            array = array.join(";")
            p array
            cmd = "sceneScenesListRun('#{array}');"
            @dlg.execute_script (cmd)
        }
        ##### GOTO SCENE
        @dlg.add_action_callback("sceneSceneOpen") {|d, p|
            a = p.split(",")
            ind = Integer(a[0])
			aspect = a[1]
            model = Sketchup.active_model
            pages = model.pages
            pages.selected_page = pages[ind]
			cmd = "scene"+aspect+"List()"
            @dlg.execute_script (cmd)
	        }
        ########## PROPERTIES (to save) ##########
        ##### PROPERTY LIST
        @dlg.add_action_callback("scenePropertiesList") {|d, p|
            model = Sketchup.active_model
            page = model.pages.selected_page
            array = []
            array.push ["Axes",page.use_axes?].join(",")
            array.push ["Camera",page.use_camera?].join(",")
            array.push ["Hidden",page.use_hidden?].join(",")
            array.push ["Hidden layers",page.use_hidden_layers?].join(",")
            array.push ["Rendering options",page.use_rendering_options?].join(",")
            array.push ["Section planes",page.use_section_planes?].join(",")
            array.push ["Shadow info",page.use_shadow_info?].join(",")
            array.push ["Style",page.use_style?].join(",")
            array = array.join(";")
            cmd = "scenePropertiesListRun('#{array}');"
            @dlg.execute_script (cmd)       
        }
        ##### PROPERTY TOGGLES ON/OFF
        @dlg.add_action_callback("scenePropertyToggle") { |d, a|
            #puts "sceneProprtyToggle:#{a.inspect}"
            property, val = a.split(',')
            property.downcase!
            val = ( val == "off" ? true : false )
            model = Sketchup.active_model
            page = model.pages.selected_page
            message = "use_" + property + "="
            #p message, val
            page.__send__(message, val)
        }
        ########## LAYERS ##########
        ##### LAYERS LIST
        @dlg.add_action_callback("sceneLayersList") {|d, p|
            model = Sketchup.active_model
            layers = model.layers
            a = 0
            b=-1
            array = []
            layers.each do |layer|
                b += 1
                array[a] = []
                array[a][0] = layer.name
                array[a][1] = layer.visible?
                array[a][2] = b
                array[a] = array[a].join(",")
                a+=1
            end  #loop
            array = array.join(";")
            cmd = "sceneLayersListRun('#{array}');"
            @dlg.execute_script (cmd)       
        }
        ##### LAYER ADD
        @dlg.add_action_callback("sceneLayersAdd") {|d, p|
            model = Sketchup.active_model
            layers = model.layers
            layers.add "New layer"
			send = "New"
            cmd = "sceneLayerRename('#{send}');"
            @dlg.execute_script (cmd)
        }
        ##### LAYER TOGGLE ON/OFF
        @dlg.add_action_callback("sceneLayerToggleon") {|d, p|
            a= p.split(",")
            ind = Integer(a[0])
            model = Sketchup.active_model
            layer = model.layers[ind]
            layer.visible = false    
        }
        @dlg.add_action_callback("sceneLayerToggleoff") {|d, p|
            a= p.split(",")
            ind = Integer(a[0])
            model = Sketchup.active_model
            layer = model.layers[ind]
            layer.visible = true    
        }
        ##### LAYER RENAME
        @dlg.add_action_callback("sceneLayersRename") {|d, p|
            a = p.split(",")
            newName = a[0].to_str
            model = Sketchup.active_model
            ind = model.layers.length-1
            layer = model.layers[ind]
            layer.name = newName
        }
        ########## COMPONENTS (outliner) ##########
        ##### COMPONENT LIST
        @dlg.add_action_callback("sceneComponentsList") {|d, p|
            model = Sketchup.active_model
            entities = model.entities
			a = 0   # for position in entire entity array
			b = 0	# for visible groponents sub arrays
            array = []  # array of visible groponents
            entities.each do |entity|
				#puts entity.to_s
                if  entity.class == Sketchup::Group || entity.class == Sketchup::ComponentInstance
                    if entity.layer.visible?
                        array[b] = []
                        if  entity.class == Sketchup::ComponentInstance
                            array[b][0] = entity.definition.name
                        end  # if comp
                        if  entity.class == Sketchup::Group
                            if entity.name == ''
                                array[b][0] = "Group"  #entity.name
                            else
                                array[b][0] = entity.name
                            end
                        end  # if group
                        array[b][1] = entity.hidden?
                        array[b][2] = a #index in entire entity array
                        array[b] = array[b].join(",")
                        b += 1
                    end  # if visible
              end  # if class
			a += 1
            end  # loop
            array = array.join(";")
			#puts array
            cmd = "sceneComponentsListRun('#{array}');"
            @dlg.execute_script (cmd)      
        }
        ##### COMPONENT SHOW/HIDE ALL
        @dlg.add_action_callback("sceneComponentsToggleAll") {|d, p|
            p = p.to_s
            model = Sketchup.active_model
            entities = model.active_entities
            entities.each do |entity|
                if  entity.class == Sketchup::Group || entity.class == Sketchup::ComponentInstance
                    if entity.layer.visible?
                        entity.hidden = false if p == "Show"
                        entity.hidden = true if p == "Hide"
                    end
                end
            end   
        }
        ##### COMPONENT BOUNDING BOX
        @dlg.add_action_callback("sceneHiliteOn") {|d, p|
            entityNo =  Integer(p)
            model = Sketchup.active_model
            entities = model.active_entities
            entity = entities[entityNo]
            selection = model.selection
            selection.clear
            selection.add entity
			CgScenes.selection_bulk_change(selection)
			}
		@dlg.add_action_callback("sceneHiliteClear") {|d, p|
            model = Sketchup.active_model
            selection = model.selection
            selection.clear   
        }
        ##### COMPONENT TOGGLE ON/OFF
        @dlg.add_action_callback("sceneComponentToggleoff") {|d, p|
            a= p.split(",")
            ind = Integer(a[0])
            model = Sketchup.active_model
            entity = model.entities[ind]
            entity.hidden = false    
        }
        @dlg.add_action_callback("sceneComponentToggleon") {|d, p|
            a= p.split(",")
            ind = Integer(a[0])
            model = Sketchup.active_model
            entity = model.entities[ind]
            entity.hidden =  true    
        }
        ########## STYLES
        ##### STYLE LIST
        @dlg.add_action_callback("sceneStylesList") {|d, p|
            model = Sketchup.active_model
            styles = model.styles
            a = 0
            array = []
            styles.each do |style|
                array[a] = []
                array[a][0] = style.name
                array[a][1] = a
                array[a] = array[a].join(",")
                a+=1
            end  #loop
            array = array.join(";")
            model = Sketchup.active_model
            pages = model.pages
            name = pages.selected_page.style.name
            array2 = []
            array2[0] = array
            array2[1] = name
            array =array2.join("qq")
            cmd = "sceneStylesListRun('#{array}');"
            @dlg.execute_script (cmd)       
        }
        ##### SET STYLE
        @dlg.add_action_callback("sceneStyleUse") {|d, p|
            a=p.split(",")
            cind = Integer(a[0])
            model = Sketchup.active_model
            styles = model.styles
            style = styles[cind]
            styles.selected_style = style   
        }

        ########## CAMERA VIEWS
        @dlg.add_action_callback("sceneViewTop") {|d, p| Sketchup.send_action("viewTop:")  }
        @dlg.add_action_callback("sceneViewBottom") {|d, p| Sketchup.send_action("viewBottom:")  }
        @dlg.add_action_callback("sceneViewFront") {|d, p| Sketchup.send_action("viewFront:")  }
        @dlg.add_action_callback("sceneViewBack") {|d, p| Sketchup.send_action("viewBack:")  }
        @dlg.add_action_callback("sceneViewLeft") {|d, p| Sketchup.send_action("viewLeft:")  }
        @dlg.add_action_callback("sceneViewRight") {|d, p| Sketchup.send_action("viewRight:")  }
        @dlg.add_action_callback("sceneViewIsometric") {|d, p| Sketchup.send_action("viewIso:")  }
        @dlg.add_action_callback("sceneViewPerspective") {|d, p| Sketchup.send_action("viewPerspective:")  }
        @dlg.add_action_callback("sceneViewZoomExtents") {|d, p| Sketchup.send_action("viewZoomExtents:")  }

        ########## SCENE UPDATE
        @dlg.add_action_callback("sceneUpdate") {|d, p|
            model = Sketchup.active_model
            page = model.pages.selected_page
            page.update   
        }

        @dlg.show()

    end # def CgScenes.start

end # module CgScenes

file_loaded("chrisglasierScenes01.rb")
